# Kraken Framework - Root Component

[![Build Status](https://travis-ci.org/kraken-php/framework.svg)](https://travis-ci.org/kraken-php/framework)
[![Total Downloads](https://poser.pugx.org/kraken-php/root/downloads)](https://packagist.org/packages/kraken-php/root) 
[![Latest Stable Version](https://poser.pugx.org/kraken-php/root/v/stable)](https://packagist.org/packages/kraken-php/root) 
[![Latest Unstable Version](https://poser.pugx.org/kraken-php/root/v/unstable)](https://packagist.org/packages/kraken-php/root) 
[![License](https://poser.pugx.org/kraken-php/framework/license)](https://packagist.org/packages/kraken-php/framework)

> **Note:** This repository is part of [Kraken Framework][3]. It can be used as standalone library, but for the best 
efficiency we suggest you to also check out the rest of [Kraken Repository][5].

<br>
<p align="center">
<img src="https://avatars2.githubusercontent.com/u/15938282?v=3&s=150" />
</p>

## Description

Kraken/Root fulfills the role of application composition root. It consists of pre-configured providers, bootloaders and
core configurations for Kraken console processes and runtime containers.

## Feature Highlights

Kraken/Root features:

* Default definition providers for Kraken Framework,
* Default logic providers for Kraken Framework,
* Pre-defined configuration for console Client and Server,
* Pre-defined configuration for runtime containers,
* ...and more.

## Interface

See more in [official documentation][2].

## Requirements

* PHP-5.5, PHP-5.6 or PHP-7.0+,
* UNIX or ~~Windows~~ OS.

## Installation

```
composer require kraken-php/root
```

## Tests

Tests are provided in [Framework Repository][3].

## Documentation

Documentation for this module can be found in the [official documentation][2].

## Contributing

This library is read-only subtree split of Kraken Framework. To make contributions, please go to [Framework Repository][3].

## License

This library licensed under the same license as [Kraken Framework][3].

[1]: http://kraken-php.com
[2]: http://kraken-php.com/docs/0.3/root
[3]: https://github.com/kraken-php/framework
[4]: https://github.com/kraken-php/kraken
[5]: https://github.com/kraken-php
